

/*************************** Includes ********************************/
#include <tjpbasdg.h>
#include <stdio.h>
/************************ End of Includes ****************************/

void sensors_tst(void);
void motor_tst(void);
 void find_color(void);
 void calibrate (void);
 
 
 	int WHITE_LT, WHITE_RT, WHITE_MD, WHITE_GR, WHITE_RD, WHITE_BL; 
 		//line sensor threshholds, cds baselines
 	int COLORID;
/***************************** Main **********************************/
void main(void)
{
 	int  cds_lt, cds_rt,cds_md, cds_green, cds_red, cds_blue;
	unsigned int bl, cv, fb, rb, run_test;
  	char clear[]= "\x1b\x5B\x32\x4A\x04";  /* clear screen */ 
  	char place[]= "\x1b[1;1H";		/* Home cursor */

  init_analog();
  init_clocktjp();
  init_serial();
  init_motortjp();




  printf("%s", clear);  /*clear screen*/
  printf("%s", place);  /*home cursor*/



  printf("Select one of the following TJ PRO test procedures\n"
         "   1. scavbot color sensor \n"
	     "   2. Test  Motors(CAREFUL!!! The robot will start moving immediately!)\n\n");
	calibrate();
  run_test= read_int();

    switch (run_test)/*Select a test procedure */
       {
         case 1: sensors_tst(); break;
	   case 2: motor_tst(); break;
       }
  
}

/***************************** Sensor **********************************/
void sensors_tst(void)
{
	int cds_lt, cds_rt,cds_md, cds_green, cds_red, cds_blue;
/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  *(unsigned char *)(0x7000) = 0xFF;
  /*IRE_ON; turn on IR emitters */

  printf("%s", clear);  
  printf("%s", place);
  
  printf("\tTitle\t\tsensetjp.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tSeptember, 1998\n"
  "\tVersion\t\t1\n\n");
   
   
  printf("TALRIK JUNIOR PROFESSIONAL SENSOR READINGS\n\n");
  printf("                  mux0	mux1G	mux2	mux3R	mux4B	color\n"); 

  while(1)
  {

  /*
    Move cursor to data field position and print data1
    
    The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
  */
  
  
	LEFT_CDS;
	cds_lt=MUX;
	RIGHT_CDS;
	cds_rt=MUX;
	GREEN_CDS;
	cds_green=MUX;
	RED_CDS;
	cds_red=MUX;
	BLUE_CDS;
	cds_blue=MUX;
	
    find_color();
    printf("\x1b[10;22H   \b\b\b\b%d",cds_lt);
    printf("\x1b[10;28H   \b\b\b\b%d",cds_green);
    printf("\x1b[10;37H   \b\b\b\b%d",cds_rt);
    printf("\x1b[10;46H   \b\b\b\b%d",cds_red);
    printf("\x1b[10;52H   \b\b\b\b%d",cds_blue);          
    printf("\x1b[10;59H   \b\b\b\b%d",COLORID);          
 
    wait(50);

  }/*end while(1)*/
}//end SENSOR
/***************************** End of Sensor **********************************/


void motor_tst(void)
/**************************** motor_tst *********************************
 * Description								*
 *   Input two integers to specify the speed and direction of the left  *
 *   and right wheels. The integers must lie between -100 and +100. Any *
 *   non-digit character will terminate the integer, e.g., a blank.     *
 *									*
 *   	      CAREFUL!!! The robot will start moving immediately!	*
 *									*
 *   To input another pair of speeds, press reset to start the program  *
 *   over. 								*
 *									*
 *  Usage: This function allows you to move the robot at any fixed      *
 *         wheel speed ratios to generate either straight or circular	*
 *         motion.  							*
 ************************************************************************/
{
  int i;
/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  printf("%s", clear);  
  printf("%s", place);
 
  printf("Motor Speed = \n\n");
  printf("Press TALRIK Reset Switch to select another test.");

  while(1)
  {
    for( i=-40; i< 41; i +=5)
    {
      motorp(RIGHT_MOTOR, i); 
      motorp(LEFT_MOTOR, i);
      printf("\x1b[1;14H      ");
      printf("\x1b[1;14H%d", i);
      wait(1000);
    }

    for( i=40; i> -41; i -=5)
    {
      motorp(RIGHT_MOTOR, i); 
      motorp(LEFT_MOTOR, i);
      printf("\x1b[1;14H      ");
      printf("\x1b[1;14H%d", i);
      wait(1000);
    }
  }

}
/**************************** calibrate********************************/

//CALIBRATE
void calibrate(void)
{  
  //calibrate line detection threshhold for cds cells
	int i=0; //loop counter
	WHITE_RD=WHITE_BL=WHITE_LT=WHITE_RT=WHITE_GR=0; //initialize sensors values
	
  //for each cds cell: take 3 readings 	
  //with a delay between each.
	while(i<3)
	{
		LEFT_CDS;
		WHITE_LT=WHITE_LT+MUX;
		RIGHT_CDS;
		WHITE_RT=WHITE_RT+MUX;
		MIDDLE_CDS;
		WHITE_GR=WHITE_GR+MUX;
		BLUE_CDS;
		WHITE_BL=WHITE_BL+MUX;
		RED_CDS;
		WHITE_RD=WHITE_RD+MUX;
		wait(25);
		i++;
	}
	      
  //Find mean.  
  //Knock off 10 points as a noise buffer,
  //set as threshhold for line detection 
	WHITE_LT=WHITE_LT/3 - 10;
	WHITE_RT=WHITE_RT/3 - 10;
	WHITE_MD=WHITE_GR/3 - 10;	
	WHITE_RD=WHITE_RD/3;
	WHITE_BL=WHITE_BL/3;
	WHITE_GR=WHITE_GR/3;
}//end of CALIBRATE
	




/**************************** find_color ******************************/

	void find_color(void)
	{
		int cds_lt, cds_rt,cds_md, cds_green, cds_red, cds_blue;
		
		LEFT_CDS;
		cds_lt=MUX;
		RIGHT_CDS;
		cds_rt=MUX;
		MIDDLE_CDS;
		cds_md=MUX;
		GREEN_CDS;
		cds_green=MUX;
		RED_CDS;
		cds_red=MUX;
		BLUE_CDS;
		cds_blue=MUX;
		
		if ((cds_lt<WHITE_LT)||(cds_rt<WHITE_RT)||(cds_md<WHITE_MD))
		{	
			if (cds_green <= WHITE_GR - 20)
				{
					if (cds_blue<=WHITE_BL - 30) COLORID=BLACK;
					else COLORID=RED;
				}
			else
				{
					if (cds_red <=WHITE_RD - 25) COLORID=BLUE;
					else COLORID=AVERY;	
				}
		}
		else COLORID = WHITE;
	}
			
