	.module lines12.c
	.dbfile lines12.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /************************************************************************
; * LINESDG by David Grindlinger
; * Copyright 2000
; *
; * a basic line finding and following code for my Mekatronix TJPro-based
; * robot. Code adapted with functions reproduced from software AVOIDTJP by a
; * Keith Doty, with Scott Jantz, 1998. 
;  ************************************************************************/
;  
; 
;   //includes
; 	#include <tjpbasdg.h>
; 	#include <stdio.h>
; 
;   //constants
; 	#define TIMEOUT 275 // how many iterations to carry
; 						// out an activity before timing out
; 						
; 	#define OBSTACLE 105 // avoidance threshhold for IR detectors
; 	
;   //prototypes
; 	void adjustLeft(void);
; 	void adjustRight(void);
; 	void turn(void);
; 	void locate(void);
; 	void follow(void);
; 	void calibrate(void);
; 	void pollcells(void);
; 	void pens_up(void);
; 	void left_pen_down(void);
; 	void right_pen_down(void);
; 	void getcolorvalue (void);
; 	void hivebehavior(void);
; 	void foodbehavior(void);
; 	void avoid(void);
; 	void followtrail(void);
; 	void maketrail(void);
; 	void aboutface(void);
; 	void do180(void);
; 
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
;   //global variables
; 	int WHITE_LT, WHITE_RT, WHITE_MD; //line sensor threshholds
; 	int WHITE_BL, WHITE_GR, WHITE_RD;
; 	int GOTHIVE=0;  //flag true when trail made/found from hive to food
; 	int EVENT=0; //true if changing from one lien to another
; 	int GOTFOOD =0; // //flags true when going from food to hive
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 	int FOLLOWING=0;	//flag is true when following a line
; 	int cds_lt,cds_rt,cds_md,cds_rd,cds_gr,cds_bl; //latest cds sensor values
; 	int color; //color under color detector, returned by getcolor()
; 
; 	
; 
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; //MAIN
; 	void main(void)
; 	{
; 
;  	 //init library functions
; 		init_analog();
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 		init_servotjp();
; 		init_clocktjp();
; 	  //put pens in neutral
;   	  	pens_up();
; 		wait(300);
;   	  //put bot in motion
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
;   		servo(rightmotor,rightspeed);
;   		servo(leftmotor,leftspeed);
;      		wait(500);
;   	  //calibrate sensors over white area of floor
;     		calibrate();
;   	
; 
;   //search loop--look for lines 
;   while(1)
;   {
;   	while(!FOLLOWING)
;   	{
; 	  //avoid collisions
; 		avoid();
; 	  //poll cds cells
; 	  //if line detected, aquire with locate behavior
; 		pollcells();		
; 		if (LINE) locate();
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 	}
; 	  //robot probably on a line to have returned from locate routine
; 	  //should be positioned with color detector on line . whats is it?
; 		if (color==BLACK) followtrail();
; 		if (color==RED) hivebehavior();
; 		if (color==GREEN) foodbehavior();
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 
; 	  //if not on line-- restart search loop
; 
;     wait(35); //here to avoid signalling motors too frequently
;   }
; }//end function MAIN
; 
; 
; 
; //LOCATE
; void locate(void)
; {
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
;   //variables
; 	int hits=1; //sensor hit counter
; 	int c=0; //loop counter
; 
;   	//wait for the last sensor to see the line
;   	//turn robot towards that sensor to follow line
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
;   	//if wait too long, forget it, return to search
;   	while ((c<TIMEOUT) && (hits<3))
;   	{
;   		avoid();
; 		pollcells();
; 		if (LINE) hits++;
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
; 		c++;
; 		//get color if possible
; 		if (COLOREDLINE) getcolorvalue();
; 		wait(25);
; 	}		
; 	
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 	//third hit means time to aquire line
; 	//if green or red, return to main to decide on behavior
; 	//if c=TIMEOUT, time-out the search
; 	if ((c>TIMEOUT)||(color==RED) || (color==GREEN)) {}
; 
; 	
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 	//otherwise turn away from last sensor to hit line
; 	else
; 	{	
; 		if(WHITE_LT - cds_lt < WHITE_RT - cds_rt) adjustRight();
; 		else adjustLeft();
; 		
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	  //when the program returns from adjustleft or right,
; 	  //robot should have center cds_cell over target and should be
; 	  //going straight	
; 		pollcells();
; 		getcolorvalue();
; 	}
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; }//end LOCATE
; 
; 
; 
; //FOLLOW
; void follow(void)
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; {
; 	//remember current line color
; 	int linecolor=color;	
; 
; 	//go forward
;     servo(leftmotor,leftspeed);
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
;     servo(rightmotor,rightspeed);
; 	
; 	while (FOLLOWING)
; 	{
; 		//when stray, make corrections
; 		pollcells();
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_GOTHIVE::
	.blkb 2
	.area idata
	.word 0
	.area data
_EVENT::
	.blkb 2
	.area idata
	.word 0
	.area data
_GOTFOOD::
	.blkb 2
	.area idata
	.word 0
	.area data
_FOLLOWING::
	.blkb 2
	.area idata
	.word 0
	.area text
;  IX -> 0,x
_main::
	.dbfile lines12.c
	.dbfunc main
	.dbline 59
	jsr _init_analog
	.dbline 60
	jsr _init_servotjp
	.dbline 61
	jsr _init_clocktjp
	.dbline 63
	jsr _pens_up
	.dbline 64
	ldd #300
	jsr _wait
	.dbline 66
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 67
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 68
	ldd #500
	jsr _wait
	.dbline 70
	jsr _calibrate
	bra L21
L23:
	.dbline 79
	jsr _avoid
	.dbline 82
	jsr _pollcells
	.dbline 83
	ldd _cds_lt
	cpd _WHITE_LT
	blt L29
	ldd _cds_rt
	cpd _WHITE_RT
	blt L29
	ldd _cds_md
	cpd _WHITE_MD
	bge L26
L29:
	jsr _locate
L26:
	.dbline 84
L24:
	.dbline 76
	ldd _FOLLOWING
	beq L23
	.dbline 87
	ldd _color
	bne L30
	jsr _followtrail
L30:
	.dbline 88
	ldd _color
	cpd #2
	bne L32
	jsr _hivebehavior
L32:
	.dbline 89
	ldd _color
	cpd #3
	bne L34
	jsr _foodbehavior
L34:
	.dbline 93
	ldd #35
	jsr _wait
	.dbline 94
L21:
	.dbline 74
	bra L24
L19:
	rts
;  IX -> 0,x
;  rMEM -> 2,x
;           hits -> 4,x
;              c -> 6,x
_locate::
	jsr __enterb
	.byte 0x8
	.dbfunc locate
	.dbline 103
	ldd #1
	std 4,x
	.dbline 104
	ldd #0
	std 6,x
	bra L38
L37:
	.dbline 111
	jsr _avoid
	.dbline 112
	jsr _pollcells
	.dbline 113
	ldd _cds_lt
	cpd _WHITE_LT
	blt L43
	ldd _cds_rt
	cpd _WHITE_RT
	blt L43
	ldd _cds_md
	cpd _WHITE_MD
	bge L40
L43:
	ldd 4,x
	addd #1
	std 4,x
L40:
	.dbline 114
	ldd 6,x
	addd #1
	std 6,x
	.dbline 116
	ldd _cds_gr
	cpd _WHITE_GR
	blt L46
	ldd _cds_rd
	cpd _WHITE_RD
	bge L44
L46:
	jsr _getcolorvalue
L44:
	.dbline 117
	ldd #25
	jsr _wait
	.dbline 118
L38:
	.dbline 109
	ldd 6,x
	cpd #275
	bge L47
	ldd 4,x
	cpd #3
	blt L37
L47:
	.dbline 123
	ldd 6,x
	cpd #275
	bgt L51
	ldd _color
	cpd #2
	beq L51
	ldd _color
	cpd #3
	bne L48
L51:
	bra L49
L48:
	.dbline 129
	ldd _WHITE_RT
	subd _cds_rt
	std 2,x
	ldd _WHITE_LT
	subd _cds_lt
	cpd 2,x
	bge L52
	jsr _adjustRight
	bra L53
L52:
	.dbline 130
	jsr _adjustLeft
L53:
	.dbline 135
	jsr _pollcells
	.dbline 136
	jsr _getcolorvalue
	.dbline 137
L49:
	.dbline 138
L36:
	xgdx
	addd #8
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;      linecolor -> 2,x
_follow::
	jsr __enterb
	.byte 0x4
	.dbfunc follow
	.dbline 146
	ldd _color
	std 2,x
	.dbline 149
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 150
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	bra L56
L55:
	.dbline 155
	jsr _pollcells
	.dbline 156
; 		if (cds_lt<WHITE_LT) adjustLeft();
	ldd _cds_lt
	cpd _WHITE_LT
	bge L58
	jsr _adjustLeft
L58:
	.dbline 157
; 		if (cds_rt<WHITE_RT) adjustRight();
	ldd _cds_rt
	cpd _WHITE_RT
	bge L60
	jsr _adjustRight
L60:
	.dbline 158
; 		wait(30);
	ldd #30
	jsr _wait
	.dbline 161
; 		//if hit line of different color
; 		//leave follow behavior
; 		getcolorvalue();
	jsr _getcolorvalue
	.dbline 162
; 		if (color!=linecolor) FOLLOWING=0;
	ldd _color
	cpd 2,x
	beq L62
	ldd #0
	std _FOLLOWING
L62:
	.dbline 163
L56:
	.dbline 152
	ldd _FOLLOWING
	bne L55
	.dbline 164
; 	}
; }//end FOLLOW
L54:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_adjustLeft::
	jsr __enterb
	.byte 0x4
	.dbfunc adjustLeft
	.dbline 170
; 
; 
; //ADJUSTLEFT
; void adjustLeft(void)
; {
; 	int c=0; //loop count
	ldd #0
	std 2,x
	.dbline 174
; 
;   //stop or reverse one motor until the some cds cell
;   //  passes over the line, or times out
; 	servo(leftmotor,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	bra L66
L65:
	.dbline 178
; 	
; 	while (c<TIMEOUT)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 181
;         
;         //if center cds sensor crosses line, go straight again
; 		if (LINE) servo(leftmotor,leftspeed);
	ldd _cds_lt
	cpd _WHITE_LT
	blt L71
	ldd _cds_rt
	cpd _WHITE_RT
	blt L71
	ldd _cds_md
	cpd _WHITE_MD
	bge L68
L71:
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
L68:
	.dbline 182
;         if (cds_md<WHITE_MD)
	ldd _cds_md
	cpd _WHITE_MD
	bge L72
	.dbline 184
;         {
;         	break;
	bra L67
L72:
	.dbline 188
;         }	
;         
;         //if left cds sensor hits, adjust right
;         else if (cds_lt<WHITE_LT)
	ldd _cds_lt
	cpd _WHITE_LT
	bge L74
	.dbline 190
;         {
;         	adjustRight();
	jsr _adjustRight
	.dbline 191
;         	break;
	bra L67
L74:
	.dbline 195
;         }	
;         
;         //if right cds cell hit, adjust left
;        else if (cds_rt<WHITE_RT)
	ldd _cds_rt
	cpd _WHITE_RT
	bge L76
	.dbline 197
;         {
;         	adjustLeft();
	jsr _adjustLeft
	.dbline 198
;         	break;
	bra L67
L76:
	.dbline 201
	ldd #20
	jsr _wait
	.dbline 202
	ldd 2,x
	addd #1
	std 2,x
	.dbline 203
L66:
	.dbline 176
	ldd 2,x
	cpd #275
	blt L65
L67:
	.dbline 205
;         }	        	
; 
; 		wait(20);
; 		c++;
; 	}	
; 
;     servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 208
; 
; 	//if timed out, turn off following flag
; 	if (c>=TIMEOUT) 
	ldd 2,x
	cpd #275
	blt L78
	.dbline 210
; 	{
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 211
; 		color=WHITE;
	ldd #1
	std _color
	.dbline 212
; 	}
L78:
	.dbline 214
; 
; }//end ADJUSTLEFT
L64:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_adjustRight::
	jsr __enterb
	.byte 0x4
	.dbfunc adjustRight
	.dbline 220
; 
; 
; //ADJUSTRIGHT
; void adjustRight(void)
; {
; 	int c=0; //loop count
	ldd #0
	std 2,x
	.dbline 224
; 
;   //stop or reverse one motor until the some cds cell
;   //  passes over the line, or routine times out
; 	servo(rightmotor,0); 
	ldd #0
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	bra L82
L81:
	.dbline 228
; 	
; 	while(c<TIMEOUT)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 232
;         
;         //if center cds sensor crosses line
;         //then go straight again
; 		if (LINE) servo(rightmotor,rightspeed);
	ldd _cds_lt
	cpd _WHITE_LT
	blt L87
	ldd _cds_rt
	cpd _WHITE_RT
	blt L87
	ldd _cds_md
	cpd _WHITE_MD
	bge L84
L87:
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
L84:
	.dbline 233
;         if (cds_md<WHITE_MD)
	ldd _cds_md
	cpd _WHITE_MD
	bge L88
	.dbline 235
;         {
;         	break;
	bra L83
L88:
	.dbline 239
;         }	
;         
;         //if left cds sensor hits, adjust right
;         if (cds_lt<WHITE_LT)
	ldd _cds_lt
	cpd _WHITE_LT
	bge L90
	.dbline 241
;         {
;         	adjustRight();
	jsr _adjustRight
	.dbline 242
;         	break;
	bra L83
L90:
	.dbline 246
;         }	
;         
;         //if right cds cell hit, adjust left
;         if (cds_rt<WHITE_RT)
	ldd _cds_rt
	cpd _WHITE_RT
	bge L92
	.dbline 248
;         {
;         	adjustLeft();
	jsr _adjustLeft
	.dbline 249
;         	break;
	bra L83
L92:
	.dbline 252
	ldd #20
	jsr _wait
	.dbline 253
	ldd 2,x
	addd #1
	std 2,x
	.dbline 254
L82:
	.dbline 226
	ldd 2,x
	cpd #275
	blt L81
L83:
	.dbline 257
;         }	        	
; 
; 		wait(20);
; 		c++;
; 	}	
; 	//if timed out, turn off following flag
; 	
;     servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 258
; 	if (c>=TIMEOUT) 
	ldd 2,x
	cpd #275
	blt L94
	.dbline 260
; 	{
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 261
; 		color=WHITE;
	ldd #1
	std _color
	.dbline 262
; 	}
L94:
	.dbline 264
; 	
; }//end ADJUSTRIGHT
L80:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
_followtrail::
	.dbfunc followtrail
	.dbline 272
; 
; 
; 
; //FOLLOWTRAIL
; void followtrail(void)
; {
;    //follow current line
; 	follow();
	jsr _follow
	.dbline 275
;   //when come back, either lost trail or hit new color
;   //if found hive or food, change to appropraite behavior
; 	if (color==RED) hivebehavior();
	ldd _color
	cpd #2
	bne L97
	jsr _hivebehavior
	bra L98
L97:
	.dbline 276
; 	else if (color==GREEN) foodbehavior();
	ldd _color
	cpd #3
	bne L99
	jsr _foodbehavior
L99:
L98:
	.dbline 278
;   //if lost line, go back to main loop
; }
L96:
	rts
;  IX -> 0,x
_hivebehavior::
	.dbfunc hivebehavior
	.dbline 286
; 
; 
; 
; //HIVEBEHAVIOR
; void hivebehavior(void)
; {
; 	//if you have food, drop it, go back to food
; 	if (GOTFOOD)
	ldd _GOTFOOD
	beq L102
	.dbline 288
; 	{
; 		pens_up();
	jsr _pens_up
	.dbline 289
; 		GOTHIVE=1;
	ldd #1
	std _GOTHIVE
	.dbline 290
; 		GOTFOOD=0;
	ldd #0
	std _GOTFOOD
	.dbline 291
; 		aboutface();
	jsr _aboutface
	.dbline 292
; 		if (FOLLOWING) followtrail();
	ldd _FOLLOWING
	beq L104
	jsr _followtrail
L104:
	.dbline 293
; 	}
L102:
	.dbline 296
; 	
; 	//if no food, turn 'em out to go find some
; 	if (!FOLLOWING)
	ldd _FOLLOWING
	bne L106
	.dbline 298
; 	{
;    		servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 299
;     		servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 300
;     		wait(500);
	ldd #500
	jsr _wait
	.dbline 301
; 		turn();
	jsr _turn
	.dbline 302
;     		servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 303
;     		servo(rightmotor,rightspeed);   
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 304
;     	}
L106:
	.dbline 305
; }//end HIVEBEHAVIOR
L101:
	rts
;  IX -> 0,x
_foodbehavior::
	.dbfunc foodbehavior
	.dbline 313
; 
; 
; 
; //FOODBEHAVIOR
; void foodbehavior(void)
; {
; 	//get some food
; 	GOTFOOD=1;
	ldd #1
	std _GOTFOOD
	.dbline 316
; 
; 	//if coming from hive, turnaround
; 	if (GOTHIVE)
	ldd _GOTHIVE
	beq L109
	.dbline 318
; 	{
; 		aboutface();
	jsr _aboutface
	.dbline 319
; 		if (FOLLOWING) followtrail();
	ldd _FOLLOWING
	beq L110
	jsr _followtrail
	.dbline 322
; 		//retrace line as returning
; 		left_pen_down;
; 	}
	bra L110
L109:
	.dbline 329
; 
; 	//if no food, follow green "foodline" until end
; 	//start drawing line back to food
; 
; 	else
; 	{
; 		do180();
	jsr _do180
	.dbline 330
; 		maketrail();
	jsr _maketrail
	.dbline 331
; 	}
L110:
	.dbline 332
; }
L108:
	rts
;  IX -> 0,x
;        DRAWING -> 2,x
_maketrail::
	jsr __enterb
	.byte 0x4
	.dbfunc maketrail
	.dbline 340
; 
; 
; 
; //MAKETRAIL
; void maketrail(void)
; //draw the trail from food to hive
; {
; 	int DRAWING=1;
	ldd #1
	std 2,x
	.dbline 342
; 	
; 	left_pen_down();
	jsr _left_pen_down
	.dbline 343
; 	servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 344
; 	servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	bra L115
L114:
	.dbline 347
; 	while(DRAWING)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 348
; 		getcolorvalue();
	jsr _getcolorvalue
	.dbline 349
; 		if (color!=WHITE)
	ldd _color
	cpd #1
	beq L117
	.dbline 351
; 		{
; 			DRAWING=0;
	ldd #0
	std 2,x
	.dbline 352
; 			pens_up();
	jsr _pens_up
	.dbline 354
; 			
; 		}
L117:
	.dbline 355
	ldd #30
	jsr _wait
	.dbline 356
L115:
	.dbline 345
	ldd 2,x
	bne L114
	.dbline 358
; 		wait(30);
; 	}
; 
; }
L113:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_aboutface::
	jsr __enterb
	.byte 0x4
	.dbfunc aboutface
	.dbline 366
; //end MAKETRAIL
; 
; 
; 
; //ABOUTFACE
; void aboutface(void)
; {
; 	int c=0;
	ldd #0
	std 2,x
	.dbline 369
; 	
; 	//start turning around, pass line with cds cells
; 	servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 370
; 	wait(100);
	ldd #100
	jsr _wait
	.dbline 372
; 	//keep turning until see line behind you
; 	pollcells();
	jsr _pollcells
	bra L121
L120:
	.dbline 375
	ldd #20
	jsr _wait
	.dbline 376
	jsr _pollcells
	.dbline 377
	ldd 2,x
	addd #1
	std 2,x
	.dbline 378
L121:
	.dbline 373
; 	while (!COLOREDLINE)
	ldd _cds_gr
	cpd _WHITE_GR
	bge L120
	ldd _cds_rd
	cpd _WHITE_RD
	blt L120
	.dbline 380
; 	{
; 		wait(20); 
; 		pollcells();
; 		c++;
; 	}
; 	//use locate command to center on line
; 	FOLLOWING=1;
	ldd #1
	std _FOLLOWING
	.dbline 381
; } 
L119:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
_right_pen_down::
	.dbfunc right_pen_down
	.dbline 390
; //END ABOUT FACE
; 
; 
; 
; //PEN CONTROL FUNCTIONS
; //operate servo controlling pens
; void right_pen_down(void)
; { 
; 	servo(2,3100);
	ldd #3100
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 391
; }
L123:
	rts
;  IX -> 0,x
_left_pen_down::
	.dbfunc left_pen_down
	.dbline 395
; 
; void left_pen_down(void)
; {  
;    	 servo(2,1900); 
	ldd #1900
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 396
; }
L124:
	rts
;  IX -> 0,x
_pens_up::
	.dbfunc pens_up
	.dbline 400
;    
; void pens_up(void)
; {
;    	servo(2,2500);    
	ldd #2500
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 401
; }//end PEN CONTROL FUNCTIONS
L125:
	rts
;  IX -> 0,x
;  func temp: 2,x - 4,x
_pollcells::
	jsr __enterb
	.byte 0x4
	.dbfunc pollcells
	.dbline 410
; 
; 
; 
; //POLLCELLS
; void pollcells(void)
; //refresh values of cds cell readings
; //MUX = analog input multiplexor/expandor board
; {		
; 	LEFT_CDS;
	clr 0x6000
	.dbline 411
; 	cds_lt=MUX;
	ldd #1
	jsr _analog
	std _cds_lt
	.dbline 412
; 	RIGHT_CDS;
	ldab #2
	stab 0x6000
	.dbline 413
; 	cds_rt=MUX;
	ldd #1
	jsr _analog
	std _cds_rt
	.dbline 414
; 	GREEN_CDS;
	ldab #1
	stab 0x6000
	.dbline 415
; 	cds_md=cds_gr=MUX;
	ldd #1
	jsr _analog
	std 2,x
	std _cds_gr
	ldd 2,x
	std _cds_md
	.dbline 416
; 	BLUE_CDS;
	ldab #4
	stab 0x6000
	.dbline 417
; 	cds_bl=MUX;
	ldd #1
	jsr _analog
	std _cds_bl
	.dbline 418
; 	RED_CDS;
	ldab #3
	stab 0x6000
	.dbline 419
; 	cds_rd=MUX;
	ldd #1
	jsr _analog
	std _cds_rd
	.dbline 420
; }//end of POLLCELLS
L126:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;       gdist_sq -> 2,x
;       rdist_sq -> 4,x
;     colorvalue -> 6,x
;      gdistance -> 8,x
;      rdistance -> 10,x
_getcolorvalue::
	jsr __enterb
	.byte 0xc
	.dbfunc getcolorvalue
	.dbline 432
; 
; 
; 
; //GETCOLORVALUE
; //determine color with red/green filtered cds cells
; void getcolorvalue(void)
; {
; 	int rdistance, rdist_sq, gdistance, gdist_sq,colorvalue;
; 
;   //distances = distance of filtered cds_cell from white
; 
; 	rdistance=WHITE_RD-cds_rd;
	ldd _WHITE_RD
	subd _cds_rd
	std 10,x
	.dbline 433
; 	gdistance=WHITE_GR-cds_gr;
	ldd _WHITE_GR
	subd _cds_gr
	std 8,x
	.dbline 436
; 
;   //normalize distances
;   	rdistance=rdistance*120/WHITE_RD;
	ldd #120
	ldy 10,x
	jsr __muli
	ldy _WHITE_RD
	jsr __divi
	std 10,x
	.dbline 437
;   	gdistance=gdistance*120/WHITE_GR;
	ldd #120
	ldy 8,x
	jsr __muli
	ldy _WHITE_GR
	jsr __divi
	std 8,x
	.dbline 439
; 	
; 	colorvalue=rdistance+gdistance;
	ldd 10,x
	addd 8,x
	std 6,x
	.dbline 441
; 	
; 	if (colorvalue<40) color=WHITE;
	ldd 6,x
	cpd #40
	bge L128
	ldd #1
	std _color
	bra L129
L128:
	.dbline 442
; 	else if (colorvalue>130) color = BLACK;
	ldd 6,x
	cpd #130
	ble L130
	ldd #0
	std _color
	bra L131
L130:
	.dbline 443
; 	else if (gdistance>rdistance) color = RED;
	ldd 8,x
	cpd 10,x
	ble L132
	ldd #2
	std _color
	bra L133
L132:
	.dbline 444
; 	else color=GREEN;
	ldd #3
	std _color
L133:
L131:
L129:
	.dbline 446
; 	
; }//end GETCOLORVALUE
L127:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_avoid::
	.dbfunc avoid
	.dbline 460
; 	
; 
; 
; //AVOID
; void avoid(void)
; //checks IR for obstacles
; //and bumpers for collisions
; {
; 
;   //check for collision and
;   //look with IR for upcoming collisions
;   //if bumped, or center IR detects object, backup and turn
;   	
; 	if ( (MIDDLE_IR>OBSTACLE) || (_BUMP) )
	ldd #7
	jsr _analog
	cpd #105
	bgt L137
	ldd #0
	jsr _analog
	cpd #10
	ble L139
L137:
	.dbline 462
; 	{
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 463
;    		servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 464
;     		servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 465
;     		wait(500);
	ldd #500
	jsr _wait
	.dbline 466
; 		turn();
	jsr _turn
	.dbline 467
;     		servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 468
;     		servo(rightmotor,rightspeed);   
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 469
;     	}
	bra L139
L138:
	.dbline 475
	ldd #0
	std _FOLLOWING
	.dbline 476
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 477
	ldd #200
	jsr _wait
	.dbline 478
L139:
	.dbline 473
;     
; 
;   //if detect object to side, turn away
; 	while (LEFT_IR>OBSTACLE) 
	ldd #3
	jsr _analog
	cpd #105
	bgt L138
	bra L142
L141:
	.dbline 482
	ldd #0
	std _FOLLOWING
	.dbline 483
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 484
	ldd #200
	jsr _wait
	.dbline 485
L142:
	.dbline 480
; 	{
; 		FOLLOWING=0;
; 		servo(rightmotor, rightreverse);
; 		wait(200);
; 	}
; 	
; 	while (RIGHT_IR>OBSTACLE)
	ldd #2
	jsr _analog
	cpd #105
	bgt L141
	.dbline 487
; 	{
; 		FOLLOWING=0;
; 		servo(leftmotor, leftreverse);
; 		wait(200);
; 	}
; 	
; }// END AVOID
L134:
	rts
;  IX -> 0,x
;              i -> 2,x
;           rand -> 4,x
_turn::
	jsr __enterb
	.byte 0x6
	.dbfunc turn
	.dbline 497
; 
; 
; 
; //TURN
; void turn(void)
; {
; 	int i;
;  	unsigned rand;
; 
;  	rand = TCNT;
	; vol
	ldd 0x100e
	std 4,x
	.dbline 498
;  	if (rand & 0x0001)
	ldd 4,x
	anda #0
	andb #1
	cpd #0
	beq L145
	.dbline 501
;  	/*turn left*/
;  	{
;   		servo(rightmotor, rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 502
;   	 	servo(leftmotor, leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 503
;  	}
	bra L146
L145:
	.dbline 507
;  	else
;  	/*turn right*/
;  	{
;    		servo(rightmotor, rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 508
;    		servo(leftmotor, leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 509
;  	}
L146:
	.dbline 511
; 
;  	i=(rand % 1024);
	ldd 4,x
	anda #3
	andb #255
	std 2,x
	.dbline 512
;  	if(i>250) wait(i); else wait(250);
	ldd 2,x
	cpd #250
	ble L147
	ldd 2,x
	jsr _wait
	bra L148
L147:
	ldd #250
	jsr _wait
L148:
	.dbline 513
; }//end of TURN
L144:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;          ?temp -> 2,x
;              i -> 4,x
_calibrate::
	jsr __enterb
	.byte 0x6
	.dbfunc calibrate
	.dbline 522
; 
; 
; 
; //CALIBRATE
; void calibrate(void)
;   //establish threshold for line/color detection on surface
; {  
;   //calibrate line detection threshhold for cds cells
; 	int i=0; //loop counter
	ldd #0
	std 4,x
	.dbline 523
; 	WHITE_LT=WHITE_RT=WHITE_MD=0; //initialize sensors values
	ldd #0
	std _WHITE_MD
	ldd #0
	std _WHITE_RT
	ldd #0
	std _WHITE_LT
	.dbline 524
; 	WHITE_RD=WHITE_GR=WHITE_BL=0;
	ldd #0
	std _WHITE_BL
	ldd #0
	std _WHITE_GR
	ldd #0
	std _WHITE_RD
	bra L151
L150:
	.dbline 530
	jsr _pollcells
	.dbline 531
	ldd _WHITE_LT
	addd _cds_lt
	std _WHITE_LT
	.dbline 532
	ldd _WHITE_RT
	addd _cds_rt
	std _WHITE_RT
	.dbline 533
	ldd _WHITE_MD
	addd _cds_md
	std _WHITE_MD
	.dbline 534
	ldd _WHITE_BL
	addd _cds_bl
	std _WHITE_BL
	.dbline 535
	ldd _WHITE_RD
	addd _cds_rd
	std _WHITE_RD
	.dbline 536
	ldd #25
	jsr _wait
	.dbline 537
	ldd 4,x
	addd #1
	std 4,x
	.dbline 538
L151:
	.dbline 528
; 	
;   //for each cds cell: take 3 readings 	
;   //with a delay between each.
; 	while(i<3)
	ldd 4,x
	cpd #3
	blt L150
	.dbline 543
; 	{
; 		pollcells();
; 		WHITE_LT=WHITE_LT+cds_lt;
; 		WHITE_RT=WHITE_RT+cds_rt;
; 		WHITE_MD=WHITE_MD+cds_md;
; 		WHITE_BL=WHITE_BL+cds_bl;
; 		WHITE_RD=WHITE_RD+cds_rd;
; 		wait(25);
; 		i++;
; 	}
; 	      
;   //Find mean.  
;   //Knock off 10 points as a noise buffer,
;   //set as threshhold for line detection 
; 	WHITE_LT=WHITE_LT/3 - 10;
	ldd _WHITE_LT
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_LT
	.dbline 544
; 	WHITE_RT=WHITE_RT/3 - 10;
	ldd _WHITE_RT
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_RT
	.dbline 545
; 	WHITE_GR=WHITE_MD=WHITE_MD/3 - 10;
	ldd _WHITE_MD
	ldy #3
	jsr __divi
	subd #10
	std 2,x
	std _WHITE_MD
	ldd 2,x
	std _WHITE_GR
	.dbline 546
; 	WHITE_BL=WHITE_BL/3 - 10;
	ldd _WHITE_BL
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_BL
	.dbline 547
; 	WHITE_RD=WHITE_RD/3 - 10;
	ldd _WHITE_RD
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_RD
	.dbline 549
; 
; }//end of CALIBRATE
L149:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_do180::
	.dbfunc do180
	.dbline 554
; 	
; 	
; void do180(void)
; {
; 	servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 555
; 	servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 556
; 	wait(1250);
	ldd #1250
	jsr _wait
	.dbline 557
; 	servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 558
; }
L153:
	rts
	.area bss
_color::
	.blkb 2
_cds_bl::
	.blkb 2
_cds_gr::
	.blkb 2
_cds_rd::
	.blkb 2
_cds_md::
	.blkb 2
_cds_rt::
	.blkb 2
_cds_lt::
	.blkb 2
_WHITE_RD::
	.blkb 2
_WHITE_GR::
	.blkb 2
_WHITE_BL::
	.blkb 2
_WHITE_MD::
	.blkb 2
_WHITE_RT::
	.blkb 2
_WHITE_LT::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
