	.module lines13.c
	.dbfile lines13.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\ICCTJP\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 41
; /************************************************************************
; * LINESDG by David Grindlinger
; * Copyright 2000
; *
; * a basic line finding and following code for my Mekatronix TJPro-based
; * robot. Code adapted with functions reproduced from software AVOIDTJP by a
; * Keith Doty, with Scott Jantz, 1998. 
;  ************************************************************************/
;  
; 
;   //includes
; 	#include <tjpbasdg.h>
; 	#include <stdio.h>
; 
;   //constants
; 	#define TIMEOUT 275 // how many iterations to carry
; 						// out an activity before timing out
; 						
; 	#define OBSTACLE 105 // avoidance threshhold for IR detectors
; 	
;   //prototypes
; 	void adjustLeft(void);
; 	void adjustRight(void);
; 	void turn(void);
; 	void locate(void);
; 	void follow(void);
; 	void calibrate(void);
; 	void pollcells(void);
; 	void pens_up(void);
; 	void left_pen_down(void);
; 	void right_pen_down(void);
; 	void getcolorvalue (void);
; 	void hivebehavior(void);
; 	void foodbehavior(void);
; 	void avoid(void);
; 	void followtrail(void);
; 	void maketrail(void);
; 	void aboutface(void);
; 	void do180(void);
; 
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 47
;   //global variables
; 	int WHITE_LT, WHITE_RT, WHITE_MD; //line sensor threshholds
; 	int WHITE_BL, WHITE_GR, WHITE_RD;
; 	int GOTHIVE=0;  //flag true when trail made/found from hive to food
; 	int EVENT=0; //true if changing from one lien to another
; 	int GOTFOOD =0; // //flags true when going from food to hive
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 53
; 	int FOLLOWING=0;	//flag is true when following a line
; 	int cds_lt,cds_rt,cds_md,cds_rd,cds_gr,cds_bl; //latest cds sensor values
; 	int color=WHITE; //color under color detector, returned by getcolor()
; 
; 	
; 
L4:
	rti
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 59
; //MAIN
; 	void main(void)
; 	{
; 
;  	 //init library functions
; 		init_analog();
L5:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 65
; 		init_servotjp();
; 		init_clocktjp();
; 	  //put pens in neutral
;   	  	pens_up();
; 		wait(300);
;   	  //put bot in motion
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 83
;   		servo(rightmotor,rightspeed);
;   		servo(leftmotor,leftspeed);
;      		wait(500);
;   	  //calibrate sensors over white area of floor
;     		calibrate();
;   	
; 
;   //search loop--look for lines 
;   while(1)
;   {
;   	printf("main\n");
;   	while(!FOLLOWING)
;   	{
; 	  //avoid collisions
; 		avoid();
; 	  //poll cds cells
; 	  //if line detected, aquire with locate behavior
; 		pollcells();
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 89
; 		if (LINE) printf("m:line\n");
; 		if (LINE) locate();
; 	}
; 	  //robot probably on a line to have returned from locate routine
; 	  //should be positioned with color detector on line . whats is it?
; 	  	printf("m:color = %d\n",color);
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 101
; 		if (color==BLACK) {printf("m:bk-f_trl\n");followtrail();}
; 		if (color==RED) {printf("m:rd-hv_bhvr\n");hivebehavior();}
; 		if (color==GREEN) {printf("m:gr-fd_bhvr\n");foodbehavior();}
; 
; 	  //if not on line-- restart search loop
; 
;     wait(35); //here to avoid signalling motors too frequently
;   }
; }//end function MAIN
; 
; 
; 
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 107
; //LOCATE
; void locate(void)
; {
; 
;   //variables
; 	int hits=1; //sensor hit counter
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 113
; 	int c=0; //loop counter
; 	printf("locate\n");
;   	//wait for the last sensor to see the line
;   	//turn robot towards that sensor to follow line
;   	//if wait too long, forget it, return to search
;   	while ((c<TIMEOUT) && (hits<3))
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 119
;   	{
;   		avoid();
; 		pollcells();
; 		if (LINE) hits++;
; 		c++;
; 		//get color if possible
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 125
; 		if (COLOREDLINE) 
; 		{
; 			printf("lct: ");
; 			getcolorvalue();
; 			//if color =red or green, escape locate routine
; 			if ((color==RED)||(color==GREEN)) 
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 131
; 			{
; 				FOLLOWING=1;
; 				c=TIMEOUT+1;
; 			}
; 		}
; 	}		
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 137
; 	
; 	//third hit means time to aquire line
; 	//if green or red, return to main to decide on behavior
; 	//if c=TIMEOUT, time-out the search
; 	if (c>TIMEOUT){}
; 
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 143
; 	
; 	//otherwise turn away from last sensor to hit line
; 	else
; 	{	
; 		printf("lct_aquire: ");
; 		if(WHITE_LT - cds_lt < WHITE_RT - cds_rt) adjustRight();
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 149
; 		else adjustLeft();
; 		
; 	  //when the program returns from adjustleft or right,
; 	  //robot should have center cds_cell over target and should be
; 	  //going straight	
; 		pollcells();
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 155
; 		getcolorvalue();
; 		FOLLOWING=1;
; 	}
; }//end LOCATE
; 
; 
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area data
_GOTHIVE::
	.blkb 2
	.area idata
	.word 0
	.area data
_EVENT::
	.blkb 2
	.area idata
	.word 0
	.area data
_GOTFOOD::
	.blkb 2
	.area idata
	.word 0
	.area data
_FOLLOWING::
	.blkb 2
	.area idata
	.word 0
	.area data
_color::
	.blkb 2
	.area idata
	.word 1
	.area text
;  IX -> 0,x
_main::
	.dbfile lines13.c
	.dbfunc main
	.dbline 59
	jsr _init_analog
	.dbline 60
	jsr _init_servotjp
	.dbline 61
	jsr _init_clocktjp
	.dbline 63
	jsr _pens_up
	.dbline 64
	ldd #300
	jsr _wait
	.dbline 66
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 67
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 68
	ldd #500
	jsr _wait
	.dbline 70
	jsr _calibrate
	jmp L21
L20:
	.dbline 76
	ldd #L23
	jsr _printf
	bra L25
L24:
	.dbline 80
	jsr _avoid
	.dbline 83
	jsr _pollcells
	.dbline 84
	ldd _cds_lt
	cpd _WHITE_LT
	blt L30
	ldd _cds_rt
	cpd _WHITE_RT
	blt L30
	ldd _cds_md
	cpd _WHITE_MD
	bge L27
L30:
	ldd #L31
	jsr _printf
L27:
	.dbline 85
	ldd _cds_lt
	cpd _WHITE_LT
	blt L35
	ldd _cds_rt
	cpd _WHITE_RT
	blt L35
	ldd _cds_md
	cpd _WHITE_MD
	bge L32
L35:
	jsr _locate
L32:
	.dbline 86
L25:
	.dbline 77
	ldd _FOLLOWING
	beq L24
	.dbline 89
	ldd _color
	pshb
	psha
	ldd #L36
	jsr _printf
	puly
	.dbline 90
	ldd _color
	bne L37
	ldd #L39
	jsr _printf
	jsr _followtrail
L37:
	.dbline 91
	ldd _color
	cpd #2
	bne L40
	ldd #L42
	jsr _printf
	jsr _hivebehavior
L40:
	.dbline 92
	ldd _color
	cpd #3
	bne L43
	ldd #L45
	jsr _printf
	jsr _foodbehavior
L43:
	.dbline 96
	ldd #35
	jsr _wait
	.dbline 97
L21:
	.dbline 74
	jmp L20
L19:
	rts
;  IX -> 0,x
;  rMEM -> 2,x
;           hits -> 4,x
;              c -> 6,x
_locate::
	jsr __enterb
	.byte 0x8
	.dbfunc locate
	.dbline 107
	ldd #1
	std 4,x
	.dbline 108
	ldd #0
	std 6,x
	.dbline 109
	ldd #L47
	jsr _printf
	bra L49
L48:
	.dbline 115
	jsr _avoid
	.dbline 116
	jsr _pollcells
	.dbline 117
	ldd _cds_lt
	cpd _WHITE_LT
	blt L54
	ldd _cds_rt
	cpd _WHITE_RT
	blt L54
	ldd _cds_md
	cpd _WHITE_MD
	bge L51
L54:
	ldd 4,x
	addd #1
	std 4,x
L51:
	.dbline 118
	ldd 6,x
	addd #1
	std 6,x
	.dbline 120
	ldd _cds_gr
	cpd _WHITE_GR
	blt L57
	ldd _cds_rd
	cpd _WHITE_RD
	bge L55
L57:
	.dbline 122
	ldd #L58
	jsr _printf
	.dbline 123
	jsr _getcolorvalue
	.dbline 125
	ldd _color
	cpd #2
	beq L61
	ldd _color
	cpd #3
	bne L59
L61:
	.dbline 127
	ldd #1
	std _FOLLOWING
	.dbline 128
	ldd #276
	std 6,x
	.dbline 129
L59:
	.dbline 130
L55:
	.dbline 131
L49:
	.dbline 113
	ldd 6,x
	cpd #275
	bge L62
	ldd 4,x
	cpd #3
	bge X0
	jmp L48
X0:
L62:
	.dbline 136
	ldd 6,x
	cpd #275
	ble L63
	bra L64
L63:
	.dbline 142
	ldd #L65
	jsr _printf
	.dbline 143
	ldd _WHITE_RT
	subd _cds_rt
	std 2,x
	ldd _WHITE_LT
	subd _cds_lt
	cpd 2,x
	bge L66
	jsr _adjustRight
	bra L67
L66:
	.dbline 144
	jsr _adjustLeft
L67:
	.dbline 149
	jsr _pollcells
	.dbline 150
	jsr _getcolorvalue
	.dbline 151
	ldd #1
	std _FOLLOWING
	.dbline 152
L64:
	.dbline 153
L46:
	xgdx
	addd #8
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;      linecolor -> 2,x
_follow::
	jsr __enterb
	.byte 0x4
	.dbfunc follow
	.dbline 162
; 
; //FOLLOW
; void follow(void)
; {
; 
; 	//remember current line color
; 	int linecolor=color;	
	ldd _color
	std 2,x
	.dbline 165
; 
; 	//go forward
;     servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 166
;     servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	bra L70
L69:
	.dbline 170
; 	
; 	while (FOLLOWING)
; 	{
; 		printf("following line %d\n",linecolor);
	ldd 2,x
	pshb
	psha
	ldd #L72
	jsr _printf
	puly
	.dbline 172
; 		//when stray, make corrections
; 		pollcells();
	jsr _pollcells
	.dbline 173
; 		if (cds_lt<WHITE_LT) {printf("adj-L\n");adjustLeft();}
	ldd _cds_lt
	cpd _WHITE_LT
	bge L73
	ldd #L75
	jsr _printf
	jsr _adjustLeft
L73:
	.dbline 174
; 		if (cds_rt<WHITE_RT) {printf("adj-R\n");adjustRight();}
	ldd _cds_rt
	cpd _WHITE_RT
	bge L76
	ldd #L78
	jsr _printf
	jsr _adjustRight
L76:
	.dbline 175
; 		wait(25);
	ldd #25
	jsr _wait
	.dbline 178
; 		//if hit line of different color
; 		//leave follow behavior
; 		printf("flwng: ");getcolorvalue();
	ldd #L79
	jsr _printf
	jsr _getcolorvalue
	.dbline 179
; 		if (color!=linecolor) FOLLOWING=0;
	ldd _color
	cpd 2,x
	beq L80
	ldd #0
	std _FOLLOWING
L80:
	.dbline 180
L70:
	.dbline 168
	ldd _FOLLOWING
	bne L69
	.dbline 181
; 	}
; 	printf("following-0,color=%d\n",color);
	ldd _color
	pshb
	psha
	ldd #L82
	jsr _printf
	puly
	.dbline 182
; }//end FOLLOW
L68:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_adjustLeft::
	jsr __enterb
	.byte 0x4
	.dbfunc adjustLeft
	.dbline 188
; 
; 
; //ADJUSTLEFT
; void adjustLeft(void)
; {
; 	int c=0; //loop count
	ldd #0
	std 2,x
	.dbline 192
; 
;   //stop or reverse one motor until the some cds cell
;   //  passes over the line, or times out
; 	servo(leftmotor,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 193
; 	printf("adj-L\n");
	ldd #L75
	jsr _printf
	bra L85
L84:
	.dbline 196
; 	while (c<TIMEOUT)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 199
;         
;         //if center cds sensor crosses line, go straight again
; 		if (LINE) servo(leftmotor,leftspeed);
	ldd _cds_lt
	cpd _WHITE_LT
	blt L90
	ldd _cds_rt
	cpd _WHITE_RT
	blt L90
	ldd _cds_md
	cpd _WHITE_MD
	bge L87
L90:
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
L87:
	.dbline 200
;         if (cds_md<WHITE_MD)
	ldd _cds_md
	cpd _WHITE_MD
	bge L91
	.dbline 202
;         {
;         	break;
	bra L86
L91:
	.dbline 206
;         }	
;         
;         //if left cds sensor hits, adjust right
;         else if (cds_lt<WHITE_LT)
	ldd _cds_lt
	cpd _WHITE_LT
	bge L93
	.dbline 208
;         {
;         	adjustRight();
	jsr _adjustRight
	.dbline 209
;         	break;
	bra L86
L93:
	.dbline 213
;         }	
;         
;         //if right cds cell hit, adjust left
;        else if (cds_rt<WHITE_RT)
	ldd _cds_rt
	cpd _WHITE_RT
	bge L95
	.dbline 215
;         {
;         	adjustLeft();
	jsr _adjustLeft
	.dbline 216
;         	break;
	bra L86
L95:
	.dbline 219
	ldd #20
	jsr _wait
	.dbline 220
	ldd 2,x
	addd #1
	std 2,x
	.dbline 221
L85:
	.dbline 194
	ldd 2,x
	cpd #275
	blt L84
L86:
	.dbline 223
;         }	        	
; 
; 		wait(20);
; 		c++;
; 	}	
; 
;     servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 226
; 
; 	//if timed out, turn off following flag
; 	if (c>=TIMEOUT) 
	ldd 2,x
	cpd #275
	blt L97
	.dbline 228
; 	{
; 		printf("timeout adj-L\n");
	ldd #L99
	jsr _printf
	.dbline 229
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 230
; 		color=WHITE;
	ldd #1
	std _color
	.dbline 231
; 	}
L97:
	.dbline 233
; 
; }//end ADJUSTLEFT
L83:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_adjustRight::
	jsr __enterb
	.byte 0x4
	.dbfunc adjustRight
	.dbline 239
; 
; 
; //ADJUSTRIGHT
; void adjustRight(void)
; {
; 	int c=0; //loop count
	ldd #0
	std 2,x
	.dbline 243
; 
;   //stop or reverse one motor until the some cds cell
;   //  passes over the line, or routine times out
; 	servo(rightmotor,0); 
	ldd #0
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 244
; 	printf("adj-R\n");
	ldd #L78
	jsr _printf
	bra L102
L101:
	.dbline 247
; 	while(c<TIMEOUT)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 251
;         
;         //if center cds sensor crosses line
;         //then go straight again
; 		if (LINE) servo(rightmotor,rightspeed);
	ldd _cds_lt
	cpd _WHITE_LT
	blt L107
	ldd _cds_rt
	cpd _WHITE_RT
	blt L107
	ldd _cds_md
	cpd _WHITE_MD
	bge L104
L107:
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
L104:
	.dbline 252
;         if (cds_md<WHITE_MD)
	ldd _cds_md
	cpd _WHITE_MD
	bge L108
	.dbline 254
;         {
;         	break;
	bra L103
L108:
	.dbline 258
;         }	
;         
;         //if left cds sensor hits, adjust right
;         if (cds_lt<WHITE_LT)
	ldd _cds_lt
	cpd _WHITE_LT
	bge L110
	.dbline 260
;         {
;         	adjustRight();
	jsr _adjustRight
	.dbline 261
;         	break;
	bra L103
L110:
	.dbline 265
;         }	
;         
;         //if right cds cell hit, adjust left
;         if (cds_rt<WHITE_RT)
	ldd _cds_rt
	cpd _WHITE_RT
	bge L112
	.dbline 267
;         {
;         	adjustLeft();
	jsr _adjustLeft
	.dbline 268
;         	break;
	bra L103
L112:
	.dbline 271
	ldd #20
	jsr _wait
	.dbline 272
	ldd 2,x
	addd #1
	std 2,x
	.dbline 273
L102:
	.dbline 245
	ldd 2,x
	cpd #275
	blt L101
L103:
	.dbline 276
;         }	        	
; 
; 		wait(20);
; 		c++;
; 	}	
; 	//if timed out, turn off following flag
; 	
;     servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 277
; 	if (c>=TIMEOUT) 
	ldd 2,x
	cpd #275
	blt L114
	.dbline 279
; 	{
; 		printf("timeout adj-R\n");
	ldd #L116
	jsr _printf
	.dbline 280
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 281
; 		color=WHITE;
	ldd #1
	std _color
	.dbline 282
; 	}
L114:
	.dbline 284
; 	
; }//end ADJUSTRIGHT
L100:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
_followtrail::
	.dbfunc followtrail
	.dbline 291
; 
; 
; 
; //FOLLOWTRAIL
; void followtrail(void)
; {
; 	printf("followtrail\n");	
	ldd #L118
	jsr _printf
	.dbline 293
;    //follow current line
; 	follow();
	jsr _follow
	.dbline 296
;   //when come back, either lost trail or hit new color
;   //if found hive or food, change to appropraite behavior
; 	if (color==RED) hivebehavior();
	ldd _color
	cpd #2
	bne L119
	jsr _hivebehavior
	bra L120
L119:
	.dbline 297
; 	else if (color==GREEN) foodbehavior();
	ldd _color
	cpd #3
	bne L121
	jsr _foodbehavior
L121:
L120:
	.dbline 299
;   //if lost line, go back to main loop
; }
L117:
	rts
;  IX -> 0,x
_hivebehavior::
	.dbfunc hivebehavior
	.dbline 306
; 
; 
; 
; //HIVEBEHAVIOR
; void hivebehavior(void)
; {
; 	printf("hivebehavior\n");
	ldd #L124
	jsr _printf
	.dbline 309
; 	//if you are drawing, pens up
; 	//if you have food, drop it, go back to food
; 	if (GOTFOOD)
	ldd _GOTFOOD
	beq L125
	.dbline 311
; 	{
; 		wait(100);
	ldd #100
	jsr _wait
	.dbline 312
; 		pens_up();
	jsr _pens_up
	.dbline 313
; 		GOTHIVE=1;
	ldd #1
	std _GOTHIVE
	.dbline 314
; 		GOTFOOD=0;
	ldd #0
	std _GOTFOOD
	.dbline 315
; 		aboutface();
	jsr _aboutface
	.dbline 316
; 		if (FOLLOWING) followtrail();
	ldd _FOLLOWING
	beq L127
	jsr _followtrail
L127:
	.dbline 317
; 	}
L125:
	.dbline 320
; 	
; 	//if no food, turn 'em out to go find some
; 	if (!FOLLOWING)
	ldd _FOLLOWING
	bne L129
	.dbline 322
; 	{
;    		servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 323
;     		servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 324
;     		wait(500);
	ldd #500
	jsr _wait
	.dbline 325
; 		turn();
	jsr _turn
	.dbline 326
;     		servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 327
;     		servo(rightmotor,rightspeed);   
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 328
;     	}
L129:
	.dbline 329
; }//end HIVEBEHAVIOR
L123:
	rts
;  IX -> 0,x
_foodbehavior::
	.dbfunc foodbehavior
	.dbline 336
; 
; 
; 
; //FOODBEHAVIOR
; void foodbehavior(void)
; {
; 	printf("foodbehavior\n");
	ldd #L132
	jsr _printf
	.dbline 338
; 	//get some food
; 	GOTFOOD=1;
	ldd #1
	std _GOTFOOD
	.dbline 341
; 
; 	//if coming from hive, turnaround
; 	if (GOTHIVE)
	ldd _GOTHIVE
	beq L133
	.dbline 343
; 	{
; 		aboutface();
	jsr _aboutface
	.dbline 344
; 		if (FOLLOWING) followtrail();
	ldd _FOLLOWING
	beq L134
	jsr _followtrail
	.dbline 347
; 		//retrace line as returning
; 		left_pen_down;
; 	}
	bra L134
L133:
	.dbline 354
; 
; 	//if no food, follow green "foodline" until end
; 	//start drawing line back to food
; 
; 	else
; 	{
; 		maketrail();
	jsr _maketrail
	.dbline 355
; 	}
L134:
	.dbline 356
; }
L131:
	rts
;  IX -> 0,x
;        DRAWING -> 2,x
_maketrail::
	jsr __enterb
	.byte 0x4
	.dbfunc maketrail
	.dbline 364
; 
; 
; 
; //MAKETRAIL
; void maketrail(void)
; //draw the trail from food to hive
; {
; 	int DRAWING=1;
	ldd #1
	std 2,x
	.dbline 365
; 	printf("maketrail\n");
	ldd #L138
	jsr _printf
	.dbline 367
; 	
; 	do180();
	jsr _do180
	.dbline 369
; 	//back up radius of platform
; 	servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 370
; 	servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 371
; 	wait(150);
	ldd #150
	jsr _wait
	.dbline 374
; 	
; 	//prepare to draw with pen
; 	left_pen_down();
	jsr _left_pen_down
	.dbline 376
; 	//wait in case on other side of food to start sensor input
; 	wait(200);
	ldd #200
	jsr _wait
	.dbline 379
; 	
; 	//go straight back, looking for hive en route
; 	servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 380
; 	servo(rightmotor,rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 381
; 	wait (150);
	ldd #150
	jsr _wait
	bra L140
L139:
	.dbline 385
; 	
; 	while(DRAWING)
; 	{
; 		pollcells();
	jsr _pollcells
	.dbline 386
; 		if(COLOREDLINE)
	ldd _cds_gr
	cpd _WHITE_GR
	blt L144
	ldd _cds_rd
	cpd _WHITE_RD
	bge L142
L144:
	.dbline 388
; 		{
; 			getcolorvalue();
	jsr _getcolorvalue
	.dbline 389
; 			if (color!=WHITE)
	ldd _color
	cpd #1
	beq L145
	.dbline 391
; 			{
; 				DRAWING=0;
	ldd #0
	std 2,x
	.dbline 392
; 				pens_up();
	jsr _pens_up
	.dbline 393
; 			}
L145:
	.dbline 394
; 		}
L142:
	.dbline 395
	ldd #20
	jsr _wait
	.dbline 396
L140:
	.dbline 383
	ldd 2,x
	bne L139
	.dbline 397
; 		wait(20);
; 	}
; }
L137:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              c -> 2,x
_aboutface::
	jsr __enterb
	.byte 0x4
	.dbfunc aboutface
	.dbline 405
; //end MAKETRAIL
; 
; 
; 
; //ABOUTFACE
; void aboutface(void)
; {
; 	int c=0;
	ldd #0
	std 2,x
	.dbline 406
; 	printf("aboutface\n");
	ldd #L148
	jsr _printf
	.dbline 409
; 	
; 	//start turning around, pass line with cds cells
; 	servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 410
; 	wait(100);
	ldd #100
	jsr _wait
	.dbline 412
; 	//keep turning until see line behind you
; 	pollcells();
	jsr _pollcells
	bra L150
L149:
	.dbline 415
	ldd #20
	jsr _wait
	.dbline 416
	jsr _pollcells
	.dbline 417
	ldd 2,x
	addd #1
	std 2,x
	.dbline 418
L150:
	.dbline 413
; 	while (!COLOREDLINE)
	ldd _cds_gr
	cpd _WHITE_GR
	bge L149
	ldd _cds_rd
	cpd _WHITE_RD
	blt L149
	.dbline 420
; 	{
; 		wait(20); 
; 		pollcells();
; 		c++;
; 	}
; 	//use locate command to center on line
; 	FOLLOWING=1;
	ldd #1
	std _FOLLOWING
	.dbline 421
; } 
L147:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
_left_pen_down::
	.dbfunc left_pen_down
	.dbline 430
; //END ABOUT FACE
; 
; 
; 
; //PEN CONTROL FUNCTIONS
; //operate servo controlling pens
; void left_pen_down(void)
; { 
; 	servo(2,3100);
	ldd #3100
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 431
;    	printf("lt-pens\n");
	ldd #L153
	jsr _printf
	.dbline 432
; }
L152:
	rts
;  IX -> 0,x
_right_pen_down::
	.dbfunc right_pen_down
	.dbline 436
; 
; void right_pen_down(void)
; {  
;    	 servo(2,1900); 
	ldd #1900
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 437
;    	printf("rt_pen\n");
	ldd #L155
	jsr _printf
	.dbline 438
; }
L154:
	rts
;  IX -> 0,x
_pens_up::
	.dbfunc pens_up
	.dbline 442
;    
; void pens_up(void)
; {
;    	servo(2,2500);    
	ldd #2500
	pshb
	psha
	ldd #2
	jsr _servo
	puly
	.dbline 443
;    	printf("pens_up\n");
	ldd #L157
	jsr _printf
	.dbline 444
; }//end PEN CONTROL FUNCTIONS
L156:
	rts
;  IX -> 0,x
;  func temp: 2,x - 4,x
_pollcells::
	jsr __enterb
	.byte 0x4
	.dbfunc pollcells
	.dbline 453
; 
; 
; 
; //POLLCELLS
; void pollcells(void)
; //refresh values of cds cell readings
; //MUX = analog input multiplexor/expandor board
; {		
; 	LEFT_CDS;
	clr 0x6000
	.dbline 454
; 	cds_lt=MUX;
	ldd #1
	jsr _analog
	std _cds_lt
	.dbline 455
; 	RIGHT_CDS;
	ldab #2
	stab 0x6000
	.dbline 456
; 	cds_rt=MUX;
	ldd #1
	jsr _analog
	std _cds_rt
	.dbline 457
; 	GREEN_CDS;
	ldab #1
	stab 0x6000
	.dbline 458
; 	cds_md=cds_gr=MUX;
	ldd #1
	jsr _analog
	std 2,x
	std _cds_gr
	ldd 2,x
	std _cds_md
	.dbline 459
; 	BLUE_CDS;
	ldab #4
	stab 0x6000
	.dbline 460
; 	cds_bl=MUX;
	ldd #1
	jsr _analog
	std _cds_bl
	.dbline 461
; 	RED_CDS;
	ldab #3
	stab 0x6000
	.dbline 462
; 	cds_rd=MUX;
	ldd #1
	jsr _analog
	std _cds_rd
	.dbline 463
; }//end of POLLCELLS
L158:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;       gdist_sq -> 2,x
;       rdist_sq -> 4,x
;     colorvalue -> 6,x
;      gdistance -> 8,x
;      rdistance -> 10,x
_getcolorvalue::
	jsr __enterb
	.byte 0xc
	.dbfunc getcolorvalue
	.dbline 472
; 
; 
; 
; //GETCOLORVALUE
; //determine color with red/green filtered cds cells
; void getcolorvalue(void)
; {
; 	int rdistance, rdist_sq, gdistance, gdist_sq,colorvalue;
; 	printf("color = ");
	ldd #L160
	jsr _printf
	.dbline 475
;   //distances = distance of filtered cds_cell from white
; 
; 	rdistance=WHITE_RD-cds_rd;
	ldd _WHITE_RD
	subd _cds_rd
	std 10,x
	.dbline 476
; 	gdistance=WHITE_GR-cds_gr;
	ldd _WHITE_GR
	subd _cds_gr
	std 8,x
	.dbline 479
; 
;   //normalize distances
;   	rdistance=rdistance*120/WHITE_RD;
	ldd #120
	ldy 10,x
	jsr __muli
	ldy _WHITE_RD
	jsr __divi
	std 10,x
	.dbline 480
;   	gdistance=gdistance*120/WHITE_GR;
	ldd #120
	ldy 8,x
	jsr __muli
	ldy _WHITE_GR
	jsr __divi
	std 8,x
	.dbline 482
; 	
; 	colorvalue=rdistance+gdistance;
	ldd 10,x
	addd 8,x
	std 6,x
	.dbline 484
; 	
; 	if (colorvalue<40) color=WHITE;
	ldd 6,x
	cpd #40
	bge L161
	ldd #1
	std _color
	bra L162
L161:
	.dbline 485
; 	else if (colorvalue>130) color = BLACK;
	ldd 6,x
	cpd #130
	ble L163
	ldd #0
	std _color
	bra L164
L163:
	.dbline 486
; 	else if (gdistance>rdistance) color = RED;
	ldd 8,x
	cpd 10,x
	ble L165
	ldd #2
	std _color
	bra L166
L165:
	.dbline 487
; 	else color=GREEN;
	ldd #3
	std _color
L166:
L164:
L162:
	.dbline 488
; 	printf("%d\n",color); 
	ldd _color
	pshb
	psha
	ldd #L167
	jsr _printf
	puly
	.dbline 490
; 	
; }//end GETCOLORVALUE
L159:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_avoid::
	.dbfunc avoid
	.dbline 503
; 	
; 
; 
; //AVOID
; void avoid(void)
; //checks IR for obstacles
; //and bumpers for collisions
; {
; 
;   //check for collision and
;   //look with IR for upcoming collisions
;   //if bumped, or center IR detects object, backup and turn
; 	if ( (MIDDLE_IR>OBSTACLE) || (_BUMP) )
	ldd #7
	jsr _analog
	cpd #105
	bgt L171
	ldd #0
	jsr _analog
	cpd #10
	ble L173
L171:
	.dbline 505
; 	{
; 		FOLLOWING=0;
	ldd #0
	std _FOLLOWING
	.dbline 506
;    		servo(leftmotor,leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 507
;     		servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 508
;     		wait(500);
	ldd #500
	jsr _wait
	.dbline 509
; 		turn();
	jsr _turn
	.dbline 510
;     		servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 511
;     		servo(rightmotor,rightspeed);   
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 512
;     	}
	bra L173
L172:
	.dbline 518
	ldd #0
	std _FOLLOWING
	.dbline 519
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 520
	ldd #200
	jsr _wait
	.dbline 521
L173:
	.dbline 516
;     
; 
;   //if detect object to side, turn away
; 	while (LEFT_IR>OBSTACLE) 
	ldd #3
	jsr _analog
	cpd #105
	bgt L172
	bra L176
L175:
	.dbline 525
	ldd #0
	std _FOLLOWING
	.dbline 526
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 527
	ldd #200
	jsr _wait
	.dbline 528
L176:
	.dbline 523
; 	{
; 		FOLLOWING=0;
; 		servo(rightmotor, rightreverse);
; 		wait(200);
; 	}
; 	
; 	while (RIGHT_IR>OBSTACLE)
	ldd #2
	jsr _analog
	cpd #105
	bgt L175
	.dbline 530
; 	{
; 		FOLLOWING=0;
; 		servo(leftmotor, leftreverse);
; 		wait(200);
; 	}
; 	
; }// END AVOID
L168:
	rts
;  IX -> 0,x
;              i -> 2,x
;           rand -> 4,x
_turn::
	jsr __enterb
	.byte 0x6
	.dbfunc turn
	.dbline 540
; 
; 
; 
; //TURN
; void turn(void)
; {
; 	int i;
;  	unsigned rand;
; 
;  	rand = TCNT;
	; vol
	ldd 0x100e
	std 4,x
	.dbline 541
;  	if (rand & 0x0001)
	ldd 4,x
	anda #0
	andb #1
	cpd #0
	beq L179
	.dbline 544
;  	/*turn left*/
;  	{
;   		servo(rightmotor, rightspeed);
	ldd #3200
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 545
;   	 	servo(leftmotor, leftreverse);
	ldd #3300
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 546
;  	}
	bra L180
L179:
	.dbline 550
;  	else
;  	/*turn right*/
;  	{
;    		servo(rightmotor, rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 551
;    		servo(leftmotor, leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 552
;  	}
L180:
	.dbline 554
; 
;  	i=(rand % 1024);
	ldd 4,x
	anda #3
	andb #255
	std 2,x
	.dbline 555
;  	if(i>250) wait(i); else wait(250);
	ldd 2,x
	cpd #250
	ble L181
	ldd 2,x
	jsr _wait
	bra L182
L181:
	ldd #250
	jsr _wait
L182:
	.dbline 556
; }//end of TURN
L178:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
;          ?temp -> 2,x
;              i -> 4,x
_calibrate::
	jsr __enterb
	.byte 0x6
	.dbfunc calibrate
	.dbline 565
; 
; 
; 
; //CALIBRATE
; void calibrate(void)
;   //establish threshold for line/color detection on surface
; {  
;   //calibrate line detection threshhold for cds cells
; 	int i=0; //loop counter
	ldd #0
	std 4,x
	.dbline 566
; 	WHITE_LT=WHITE_RT=WHITE_MD=0; //initialize sensors values
	ldd #0
	std _WHITE_MD
	ldd #0
	std _WHITE_RT
	ldd #0
	std _WHITE_LT
	.dbline 567
; 	WHITE_RD=WHITE_GR=WHITE_BL=0;
	ldd #0
	std _WHITE_BL
	ldd #0
	std _WHITE_GR
	ldd #0
	std _WHITE_RD
	.dbline 568
; 	printf("calibrate\n");
	ldd #L184
	jsr _printf
	bra L186
L185:
	.dbline 574
	jsr _pollcells
	.dbline 575
	ldd _WHITE_LT
	addd _cds_lt
	std _WHITE_LT
	.dbline 576
	ldd _WHITE_RT
	addd _cds_rt
	std _WHITE_RT
	.dbline 577
	ldd _WHITE_MD
	addd _cds_md
	std _WHITE_MD
	.dbline 578
	ldd _WHITE_BL
	addd _cds_bl
	std _WHITE_BL
	.dbline 579
	ldd _WHITE_RD
	addd _cds_rd
	std _WHITE_RD
	.dbline 580
	ldd #25
	jsr _wait
	.dbline 581
	ldd 4,x
	addd #1
	std 4,x
	.dbline 582
L186:
	.dbline 572
; 	
;   //for each cds cell: take 3 readings 	
;   //with a delay between each.
; 	while(i<3)
	ldd 4,x
	cpd #3
	blt L185
	.dbline 587
; 	{
; 		pollcells();
; 		WHITE_LT=WHITE_LT+cds_lt;
; 		WHITE_RT=WHITE_RT+cds_rt;
; 		WHITE_MD=WHITE_MD+cds_md;
; 		WHITE_BL=WHITE_BL+cds_bl;
; 		WHITE_RD=WHITE_RD+cds_rd;
; 		wait(25);
; 		i++;
; 	}
; 	      
;   //Find mean.  
;   //Knock off 10 points as a noise buffer,
;   //set as threshhold for line detection 
; 	WHITE_LT=WHITE_LT/3 - 10;
	ldd _WHITE_LT
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_LT
	.dbline 588
; 	WHITE_RT=WHITE_RT/3 - 10;
	ldd _WHITE_RT
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_RT
	.dbline 589
; 	WHITE_GR=WHITE_MD=WHITE_MD/3 - 10;
	ldd _WHITE_MD
	ldy #3
	jsr __divi
	subd #10
	std 2,x
	std _WHITE_MD
	ldd 2,x
	std _WHITE_GR
	.dbline 590
; 	WHITE_BL=WHITE_BL/3 - 10;
	ldd _WHITE_BL
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_BL
	.dbline 591
; 	WHITE_RD=WHITE_RD/3 - 10;
	ldd _WHITE_RD
	ldy #3
	jsr __divi
	subd #10
	std _WHITE_RD
	.dbline 593
; 
; }//end of CALIBRATE
L183:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_do180::
	.dbfunc do180
	.dbline 599
; 	
; 	
; void do180(void)
; //turn 180 degrees,halt
; {
; 	printf("do180\n");
	ldd #L189
	jsr _printf
	.dbline 600
; 	servo(leftmotor,leftspeed);
	ldd #2800
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 601
; 	servo(rightmotor,rightreverse);
	ldd #2700
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 602
; 	wait(1250);
	ldd #1250
	jsr _wait
	.dbline 603
; 	servo(rightmotor,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _servo
	puly
	.dbline 604
; 	servo(leftmotor,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _servo
	puly
	.dbline 605
; }
L188:
	rts
	.area bss
_cds_bl::
	.blkb 2
_cds_gr::
	.blkb 2
_cds_rd::
	.blkb 2
_cds_md::
	.blkb 2
_cds_rt::
	.blkb 2
_cds_lt::
	.blkb 2
_WHITE_RD::
	.blkb 2
_WHITE_GR::
	.blkb 2
_WHITE_BL::
	.blkb 2
_WHITE_MD::
	.blkb 2
_WHITE_RT::
	.blkb 2
_WHITE_LT::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
	.area text
L189:
	.byte 'd,'o,49,56,48,10,0
L184:
	.byte 'c,'a,'l,'i,'b,'r,'a,'t,'e,10,0
L167:
	.byte 37,'d,10,0
L160:
	.byte 'c,'o,'l,'o,'r,32,61,32,0
L157:
	.byte 'p,'e,'n,'s,95,'u,'p,10,0
L155:
	.byte 'r,'t,95,'p,'e,'n,10,0
L153:
	.byte 'l,'t,45,'p,'e,'n,'s,10,0
L148:
	.byte 'a,'b,'o,'u,'t,'f,'a,'c,'e,10,0
L138:
	.byte 'm,'a,'k,'e,'t,'r,'a,'i,'l,10,0
L132:
	.byte 'f,'o,'o,'d,'b,'e,'h,'a,'v,'i,'o,'r,10,0
L124:
	.byte 'h,'i,'v,'e,'b,'e,'h,'a,'v,'i,'o,'r,10,0
L118:
	.byte 'f,'o,'l,'l,'o,'w,'t,'r,'a,'i,'l,10,0
L116:
	.byte 't,'i,'m,'e,'o,'u,'t,32,'a,'d,'j,45,'R,10,0
L99:
	.byte 't,'i,'m,'e,'o,'u,'t,32,'a,'d,'j,45,'L,10,0
L82:
	.byte 'f,'o,'l,'l,'o,'w,'i,'n,'g,45,48,44,'c,'o,'l,'o
	.byte 'r,61,37,'d,10,0
L79:
	.byte 'f,'l,'w,'n,'g,58,32,0
L78:
	.byte 'a,'d,'j,45,'R,10,0
L75:
	.byte 'a,'d,'j,45,'L,10,0
L72:
	.byte 'f,'o,'l,'l,'o,'w,'i,'n,'g,32,'l,'i,'n,'e,32,37
	.byte 'd,10,0
L65:
	.byte 'l,'c,'t,95,'a,'q,'u,'i,'r,'e,58,32,0
L58:
	.byte 'l,'c,'t,58,32,0
L47:
	.byte 'l,'o,'c,'a,'t,'e,10,0
L45:
	.byte 'm,58,'g,'r,45,'f,'d,95,'b,'h,'v,'r,10,0
L42:
	.byte 'm,58,'r,'d,45,'h,'v,95,'b,'h,'v,'r,10,0
L39:
	.byte 'm,58,'b,'k,45,'f,95,'t,'r,'l,10,0
L36:
	.byte 'm,58,'c,'o,'l,'o,'r,32,61,32,37,'d,10,0
L31:
	.byte 'm,58,'l,'i,'n,'e,10,0
L23:
	.byte 'm,'a,'i,'n,10,0
