

/*************************** Includes ********************************/
#include <tjpbasdg.h>
#include <stdio.h>
//#include <math.h>
/************************ End of Includes ****************************/

void sensors_tst(void);
void motor_tst(void);
void pollcells(void);
void calibrate(void);
void SET_LED(int LED, int state);
void getcolorvalue(void);
void normalizecells(void);


	int cds_lt, cds_rt,cds_md, cds_gr, cds_rd, cds_bl, color;
	int colorvalue;
	int led_state;
	int WHITE_BL,WHITE_GR, WHITE_RD, WHITE_LT, WHITE_RT, WHITE_MD;
/***************************** Main **********************************/
void main(void)
{

  unsigned int bl, cv, fb, rb, run_test;
  char clear[]= "\x1b\x5B\x32\x4A\x04";  /* clear screen */ 
  char place[]= "\x1b[1;1H";		/* Home cursor */

  init_analog();
  init_clocktjp();
  init_serial();
  init_motortjp();




  printf("%s", clear);  /*clear screen*/
  printf("%s", place);  /*home cursor*/

  printf("\tTitle\t\ttjprotst.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tMarch 22, 1999\n"
  "\tVersion\t\t1\n\n");

  run_test= 1;

    switch (run_test)/*Select a test procedure */
       {
         case 1: sensors_tst(); break;
	 
       }
  
}

/***************************** Sensor **********************************/
void sensors_tst(void)
{
/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  *(unsigned char *)(0x7000) = 0xFF;
  /*IRE_ON; turn on IR emitters */

  printf("%s", clear);  
  printf("%s", place);
  
  printf("\tTitle\t\tsensetjp.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tSeptember, 1998\n"
  "\tVersion\t\t1\n\n");
    
  printf("colorcode: 0--black   1--white   2--red   3--green\n\n");
  printf("                  mux0_LT mux1_GR mux2_rt mux3_RD colval color\n"); 
  	wait(300);
  	calibrate();
  while(1)
  {

  /*
    Move cursor to data field position and print data1
    
    The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
  */
  


	pollcells();
	getcolorvalue();


	normalizecells();
	

    //printf("\x1b[10;22H   \b\b\b\b%d",cds_lt);
    printf("\x1b[10;29H   \b\b\b\b%d",cds_gr);
  //  printf("\x1b[10;36H   \b\b\b\b%d",cds_rt);
    printf("\x1b[10;45H   \b\b\b\b%d",cds_rd);
    printf("\x1b[10;52H   \b\b\b\b%d",colorvalue);   
    printf("\x1b[10;60H   \b\b\b\b%d",color);        
    wait(50);

  }/*end while(1)*/
}
/***************************** End of Sensor **********************************/

//POLLCELLS
void pollcells(void)
{		
	LEFT_CDS;
	cds_lt=MUX;
	RIGHT_CDS;
	cds_rt=MUX;
	GREEN_CDS;
	cds_md=cds_gr=MUX;
	BLUE_CDS;
	cds_bl=MUX;
	RED_CDS;
	cds_rd=MUX;
}


void normalizecells(void)
	{
		cds_gr=cds_gr*120/WHITE_GR;
		cds_rd=cds_rd*120/WHITE_RD;
		cds_lt=cds_lt*120/WHITE_LT;
		cds_rt=cds_rt*120/WHITE_RT;
	}

//CALIBRATE
void calibrate(void)
{  
  //calibrate line detection threshhold for cds cells
	int i=0; //loop counter
	WHITE_LT=WHITE_RT=0; //initialize sensors values
	WHITE_RD=WHITE_GR=WHITE_BL=0;
	
  //for each cds cell: take 3 readings 	
  //with a delay between each.
	while(i<3)
	{
		pollcells();
		WHITE_LT=WHITE_LT+cds_lt;
		WHITE_RT=WHITE_RT+cds_rt;
		WHITE_MD=WHITE_MD+cds_md;
		WHITE_BL=WHITE_BL+cds_bl;
		WHITE_RD=WHITE_RD+cds_rd;
		wait(25);
		i++;
	}
	      
  //Find mean.  
  //Knock off 10 points as a noise buffer,
  //set as threshhold for line detection 
	WHITE_LT=WHITE_LT/3 - 10;
	WHITE_RT=WHITE_RT/3 - 10;
	WHITE_GR=WHITE_MD=WHITE_MD/3 - 10;
	WHITE_BL=WHITE_BL/3 - 10;
	WHITE_RD=WHITE_RD/3 - 10;

}//end of CALIBRATE


//GETCOLORVALUE
void getcolorvalue(void)
{
	int rdistance, rdist_sq, gdistance, gdist_sq;

  //distances = distance of filtered cds_cell from white

	rdistance=WHITE_RD-cds_rd;
	gdistance=WHITE_GR-cds_gr;
	
  //normalize distances
  	rdistance=rdistance*200/WHITE_RD;
  	gdistance=gdistance*200/WHITE_GR;
	
	colorvalue=rdistance+gdistance;
	
	if (colorvalue<20) color=WHITE;
	else if (colorvalue>180) color = BLACK;
	else if (gdistance>rdistance) color = RED;
	else color=GREEN;
	
}//end GETCOLORVALUE
