

/*************************** Includes ********************************/
#include <tjpbasdg.h>
#include <stdio.h>
/************************ End of Includes ****************************/

void aboutface(void);
void calibrate(void);
void pollcells(void);

int WHITE_LT, WHITE_RT, WHITE_MD; //line sensor threshholds
int WHITE_BL, WHITE_GR, WHITE_RD;
int cds_lt,cds_rt,cds_md,cds_rd,cds_gr,cds_bl; //latest cds sensor values
/***************************** Main **********************************/
void main(void)
{



		init_analog();
		init_servotjp();
		init_clocktjp();
		
		servo(2,2500);


		wait(200);
		calibrate();
		while(!_BUMP){}		
		servo(leftmotor,leftspeed);
		servo(rightmotor,rightspeed);
		while(1)
		{
			pollcells();
			if (!LINE) aboutface();
		}
}

//ABOUTFACE
void aboutface(void)
{
	//start turning around, pass line with cds cells
	servo(leftmotor,leftreverse);
	wait(300);
	//keep turning until see line behind you
	pollcells();
	while (cds_md<WHITE_MD) 
	{
		wait(20); 
		pollcells();
		
	}
	
	servo(leftmotor,leftspeed);

} 
//END ABOUT FACE



//POLLCELLS
void pollcells(void)
//refresh values of cds cell readings
//MUX = analog input multiplexor/expandor board
{		
	LEFT_CDS;
	cds_lt=MUX;
	RIGHT_CDS;
	cds_rt=MUX;
	GREEN_CDS;
	cds_md=cds_gr=MUX;
	BLUE_CDS;
	cds_bl=MUX;
	RED_CDS;
	cds_rd=MUX;
}//end of POLLCELLS


//CALIBRATE
void calibrate(void)
  //establish threshold for line/color detection on surface
{  
  //calibrate line detection threshhold for cds cells
	int i=0; //loop counter
	WHITE_LT=WHITE_RT=WHITE_MD=0; //initialize sensors values
	WHITE_RD=WHITE_GR=WHITE_BL=0;
	
  //for each cds cell: take 3 readings 	
  //with a delay between each.
	while(i<3)
	{
		pollcells();
		WHITE_LT=WHITE_LT+cds_lt;
		WHITE_RT=WHITE_RT+cds_rt;
		WHITE_MD=WHITE_MD+cds_md;
		WHITE_BL=WHITE_BL+cds_bl;
		WHITE_RD=WHITE_RD+cds_rd;
		wait(25);
		i++;
	}
	      
  //Find mean.  
  //Knock off 10 points as a noise buffer,
  //set as threshhold for line detection 
	WHITE_LT=WHITE_LT/3 - 10;
	WHITE_RT=WHITE_RT/3 - 10;
	WHITE_GR=WHITE_MD=WHITE_MD/3 - 10;
	WHITE_BL=WHITE_BL/3 - 10;
	WHITE_RD=WHITE_RD/3 - 10;

}//end of CALIBRATE



