

/*************************** Includes ********************************/
#include <tjpbasdg.h>
#include <stdio.h>
/************************ End of Includes ****************************/

void sensors_tst(void);
void motor_tst(void);
void setdigport(void);
/***************************** Main **********************************/
void main(void)
{

  unsigned int bl, cv, fb, rb, run_test;
  char clear[]= "\x1b\x5B\x32\x4A\x04";  /* clear screen */ 
  char place[]= "\x1b[1;1H";		/* Home cursor */

  init_analog();
  init_clocktjp();
  init_serial();
  init_motortjp();




  printf("%s", clear);  /*clear screen*/
  printf("%s", place);  /*home cursor*/

  printf("\tTitle\t\ttjprotst.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tMarch 22, 1999\n"
  "\tVersion\t\t1\n\n");

  printf("Select one of the following TJ PRO test procedures\n"
         "   1. Test TJ PRO Sensors \n"
	     "   2. Test TJ PRO Motors(CAREFUL!!! The robot will start moving immediately!)\n\n");

  run_test= 1;

    switch (run_test)/*Select a test procedure */
       {
         case 1: sensors_tst(); break;
	   case 2: motor_tst(); break;
       }
  
}

/***************************** Sensor **********************************/
void sensors_tst(void)
{
	int cds_lt, cds_rt,cds_md;
/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  *(unsigned char *)(0x7000) = 0xFF;
  /*IRE_ON; turn on IR emitters */

  printf("%s", clear);  
  printf("%s", place);
  
  printf("\tTitle\t\tsensetjp.c\n"
  "\tProgrammer\tKeith L. Doty\n"
  "\tDate\t\tSeptember, 1998\n"
  "\tVersion\t\t1\n\n");

  printf("TALRIK JUNIOR PROFESSIONAL SENSOR READINGS\n\n");
  printf("Left IR    MIDDL IR    RIGHT IR\n"); 

  while(1)
  {

  /*
    Move cursor to data field position and print data1
    
    The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
  */
  

	
    printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
    printf("\x1b[10;13H   \b\b\b\b%d",MIDDLE_IR);
    printf("\x1b[10;22H   \b\b\b\b%d",RIGHT_IR);

           
    wait(50);


  }/*end while(1)*/
}
/***************************** End of Sensor **********************************/


void motor_tst(void)
/**************************** motor_tst *********************************
 * Description								*
 *   Input two integers to specify the speed and direction of the left  *
 *   and right wheels. The integers must lie between -100 and +100. Any *
 *   non-digit character will terminate the integer, e.g., a blank.     *
 *									*
 *   	      CAREFUL!!! The robot will start moving immediately!	*
 *									*
 *   To input another pair of speeds, press reset to start the program  *
 *   over. 								*
 *									*
 *  Usage: This function allows you to move the robot at any fixed      *
 *         wheel speed ratios to generate either straight or circular	*
 *         motion.  							*
 ************************************************************************/
{
}
/**************************** motor_tst ******************************/


void setdigport(void)
{
	SET_BIT(DDRD, 0x08);
	SET_BIT(DDRD, 0x10);
	
	CLEAR_BIT(PORTD, 0x08);
	CLEAR_BIT(PORTD, 0x10);
}

